#include "bitboard.h"

#include <iostream>

using namespace std;

void Print(BITBOARD b, int level){
	if (b == 0) {
		if (level == 0) 
			cout << '0';
		return;
	}
	Print(b / 10, level+1);
	cout << (unsigned int)(b % 10);
}

void PrintBitboard(BITBOARD b){
	BITBOARD one = 1;
	//cout << "printing bitboard " ;//<< Hi(b) << Low(b) << endl;
	//Print(b);
	//cout << endl;

	for (int byte = 7; byte >=0; byte--){
		for (int bit = 0; bit <= 7; bit++)
			cout << ((b & (one << (byte * 8 + bit))) != 0) << ' ';
		cout << endl;
	}
	cout << endl;
}

BITBOARD Mirror(BITBOARD& b){
	BITBOARD result = 0;

	for (int i = 0; i < 8; i++){
		result = Shl(result, 8) | And(Shr(b, i*8), 0xff);
	}

	return result;
}


extern unsigned char first_ones[65536];
extern unsigned char last_ones[65536];


#if !VISUAL_C

int BitCount(BITBOARD a){
	int count = 0;
	while (a){
		a = And(a,a-1);
		count++;
	}
	return count;
}

int FirstOne(BITBOARD b){
	union {
		unsigned short i[4];
		BITBOARD d;
	} x;

	x.d = b;

	if (x.i[0])
		return first_ones[x.i[0]];
	else if (x.i[1])
		return first_ones[x.i[1]] + 16;
	else if (x.i[2])
		return first_ones[x.i[2]] + 32;
	else if (x.i[3])
		return first_ones[x.i[3]] + 48;
	else return 0;
}

int LastOne(BITBOARD b){
	union {
		unsigned short i[4];
		BITBOARD d;
	} x;

	x.d = b;

	if (x.i[3])
		return last_ones[x.i[3]]+48;
	else if (x.i[2])
		return last_ones[x.i[2]] + 32;
	else if (x.i[1])
		return last_ones[x.i[1]] + 16;
	else if (x.i[0])
		return last_ones[x.i[0]];
	else return 0;
}

#endif


void MirrorAndSwap(BITBOARD& b1, BITBOARD& b2){
	BITBOARD tmp = Mirror(b1);
	b1 = Mirror(b2);
	b2 = tmp;
}
